#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <SDL.h>
#include <SDL/SDL_image.h>

/* fetch SDL from libsdl.org */

/* screen width, height, and bit depth */
int SCREEN_WIDTH;
int SCREEN_HEIGHT;
int SCREEN_BPP;

double costable[360000];
double sintable[360000];

/* Set up some booleans */
#define TRUE  1
#define FALSE 0

SDL_Surface *display;
SDL_Surface *image;
SDL_Color colors[256];

typedef struct {
	float raderl;
	float wert;
	float radius_there;
} werte;

typedef struct {
	int xcoord;
	int ycoord;
	float gradient_there;
	float radius_here;
} gradients;

double fastsin( float input )
{
	int fastphi;
	double output;
	fastphi=input*1000;
	output=sintable[fastphi];
	return output;
}

double fastcos( float input )
{
	int fastphi;
	double output;
	fastphi=input*1000;
	output=costable[fastphi];
	return output;
}


int main(int argc, char **argv)
{
	image = IMG_Load( "auge3.png");

	SCREEN_WIDTH = image->w;
    	SCREEN_HEIGHT = image->h;
	SCREEN_BPP = 24;    
	
	int gsimage[SCREEN_WIDTH][SCREEN_HEIGHT]; 
	
	int c;
	for(c=0;c<255;c++)
	{
		colors[c].r=c;
	    	colors[c].g=c;
	      	colors[c].b=c;
      	}

	for(c=0;c<360000;c++)
	{
		sintable[c]=sin(c*0.001);
		costable[c]=cos(c*0.001);
      	}
      

	SDL_Init( SDL_INIT_VIDEO );

	atexit(SDL_Quit);

	display = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_HWSURFACE|SDL_DOUBLEBUF);
	SDL_ShowCursor(0);
	SDL_SetColors(display, colors, 0, 256);
	SDL_BlitSurface(image, NULL, display, NULL);
	SDL_Flip(display);
	SDL_LockSurface(display);
	
	int h, w;
	for  ( w=0; w< SCREEN_WIDTH ; w++) {
		for  ( h=0; h< SCREEN_HEIGHT ; h++) {
			Uint8 *p_in = (Uint8 *)image->pixels + h * image->pitch + w * 3;
			gsimage[w][h]=p_in[0]+p_in[1]+p_in[2];
		}
	}
	
	// mean calculation
	int radius = 10;
	int grain = 2;
	int l2,m2;
	float dr=0.1;
	int dphi=36;
	int rmin,rmax,x,y;
	float rad,phi;
	float curval=0.0;
	int counter=0;
	rmin=10;
	rmax=50;
	int z,s;
	double bar=0;
	werte werterl[1024];
	double steigung=0.0;
	double cursteigung;
	
	int counter3,counter4;
	double maxgradforcoords=0.0;
	counter4=0;
	
	int xmin=(SCREEN_WIDTH/2)-radius;
	int xmax=(SCREEN_WIDTH/2)+radius;
	int ymin=(SCREEN_HEIGHT/2)-radius;
	int ymax=(SCREEN_HEIGHT/2)+radius;
	int counter2=0;

	gradients gradvalues[(xmax-xmin)*(ymax-ymin)];
	
	for(l2=xmin;l2<xmax;l2+=grain) {
	//breaking:
		for(m2=ymin;m2<ymax;m2+=grain) {
		
			/*
			Uint8 *p_out = (Uint8 *)display->pixels + m2 * display->pitch + l2 * 3;
			p_out[2] = 255 ;
			SDL_UpdateRect(display, l2, m2, 1, 1 );
			*/
			
			// calc mean routine
			
			for (rad=rmin;rad<rmax;rad+=dr) {
				for (phi=0;phi<360;phi+=0.5) {
				
					x=rad*fastcos(phi)+l2;
					y=rad*fastsin(phi)+m2;
					curval+=gsimage[x][y];
				}
				curval/=dphi;
				werterl[counter].raderl=rad;
				werterl[counter].wert=curval;
				curval=0;
				counter++;
			}

		
			// gaussian blur
			for(z=3;z<(counter-3);z++) {
				for(s=z-3;s<=z+3;s++){
				bar+=werterl[s].wert;
				}
			werterl[z].wert=bar/7;
			bar=0;
			}
	
			// gradient	
			steigung=0;
			counter4=0;
			for(z=0;z<(counter-3);z++) {
				cursteigung=(werterl[z+3].wert-werterl[z].wert)/(werterl[z+3].raderl-werterl[z].raderl);
				
				//gradient: f(x+h)-f(x)/h
				if(cursteigung>steigung) {
					counter4=z;
					werterl[counter4].radius_there=werterl[z].raderl;
					steigung=cursteigung;

				}
			}

			counter=0;
			gradvalues[counter2].xcoord=l2;
			gradvalues[counter2].ycoord=m2;
			gradvalues[counter2].gradient_there=steigung;
			gradvalues[counter2].radius_here=werterl[counter4].radius_there;
			
			counter2++;
		}
	}
	
	//endspurt:
	counter4=0;
	for(counter3=0;counter3<counter2;counter3++){
		
		if(gradvalues[counter3].gradient_there>maxgradforcoords) {
			maxgradforcoords=gradvalues[counter3].gradient_there;
			counter4=counter3;
			}
		}
	
	Uint8 *p_out = (Uint8 *)display->pixels + gradvalues[counter4].ycoord * display->pitch + gradvalues[counter4].xcoord * 3;
	p_out[0] = 255;
					
	SDL_Flip(display);
	
	for (phi=0;phi<360;phi++) {
					x=(gradvalues[counter4].radius_here-8)*fastcos(phi)+gradvalues[counter4].xcoord;
					y=(gradvalues[counter4].radius_here-8)*fastsin(phi)+gradvalues[counter4].ycoord;
					Uint8 *p_out = (Uint8 *)display->pixels + y * display->pitch + x * 3;
                        		p_out[0] = 0 ;
                           		p_out[1] = 0 ;
					p_out[2] = 255 ;
                                                                        					p_out[0] = 255;
				}
	SDL_Flip(display);
	
	for (rad=rmin;rad<rmax;rad+=dr) {
	
				for (phi=0;phi<360;phi++) {
					x=rad*fastcos(phi)+gradvalues[counter4].xcoord;
					y=rad*fastsin(phi)+gradvalues[counter4].ycoord;
					curval+=gsimage[x][y];
					
				}
	
				
				curval/=dphi;
				curval=0;
			}
	// --
	

	int done=0;
	
	while(done == 0) {
	        SDL_Event event;
	        SDL_Delay (1);
        	while ( SDL_PollEvent(&event) ) {

			if ( event.type == SDL_QUIT ) { done = 1; } ;

               		if ( event.type == SDL_KEYDOWN ) { 
               			if ( event.key.keysym.sym == SDLK_ESCAPE ) { done = 1; } ;
               		}
               	}
        }

	return 0;
}

